const int  buttonPin = 2;    // the pin that the pushbutton is attached to

// Assign LED Output PWM Pins
int redPin = 11;
int greenPin = 10;
int bluePin = 9;
int ledState = 0;  // alle leds LOW


// Variables will change:
int counter = 1;   // counter for the number of button presses
int buttonState = 1;         // current state of the button
int lastButtonState = 0;     // previous state of the button

int inByte = 0;         // incoming serial byte

// varaiabler for timer
long previousMillis = 0;        // will store last time LED was updated
int timerState = 0;
// the follow variables is a long because the time, measured in miliseconds,
// will quickly become a bigger number than can be stored in an int.
long interval = 1500;           // HVOR LENGE DEN SKAL LYSE, før fade out
long aTriggerInterval = 500;    // HVOR LENGE DEN SKAL VENTE, FØR DEN SJEKKER ACCELEREOMTER PÅ NYTT
int aSensitivity = 150;   // Når acceleromteret skal gi utslag (snitt for x og z)

///////// VARIABLER FOR ACCELEROEMTER
//Analog read pins, accelerometer
const int xPin = 0;
const int yPin = 1;
const int zPin = 2;
//The minimum and maximum values that came from, accelerometer
//the accelerometer while standing still, accelerometer
//You very well may need to change these, accelerometer
int minVal = 265;
int maxVal = 402;
//to hold the caculated values, accelerometer
double x;
double y;
double z;

int aTrigger;

int aTriggerState = 1;
int lastaTriggerState = 0;  
void setup()
{

  // initialize the button pin as a input:
  pinMode(buttonPin, INPUT);
  // initialize the LED as an output:
  pinMode(redPin, OUTPUT);
  pinMode(greenPin, OUTPUT);
  pinMode(bluePin, OUTPUT); 

  // start serial port at 9600 bps and wait for port to open:
  Serial.begin(9600);
  while (!Serial) {
    ; // wait for serial port to connect. Needed for Leonardo only
  }

}


void loop() {
   

  acceleromter ();  // kaller accelleromterfunkjonen,

///////////////////////////////////// KNAPPKODE TIL OVERRIDES/////////////////////////
//read the pushbutton input pin:
  buttonState = digitalRead(buttonPin);

  // compare the buttonState to its previous state
  if (buttonState != lastButtonState) {
    // if the state has changed, increment the counter
    if (buttonState == HIGH) {
   // nullstille teller hvis den er over 15
      if (counter == 15){
        counter = 1;  
      }  

      Serial.print(getNumber());
      ledState = 1; // denne er der for å skry på lys
      counter++;
    } 

  }
  lastButtonState = buttonState;
  timer (); // tester hvor lenge lysa har vært på, skrur de ev. av ved å sette ledState = 0;
}



void timer (){
  //setter tiden;
  unsigned long currentMillis = millis();

  if(currentMillis - previousMillis > interval) {
    // save the last time you blinked the LED 
    previousMillis = currentMillis;   
    // // skry lys av
    ledState = 0;
  }

  // set the LED with the ledState of the variable:
  // digitalWrite(ledPin, ledState);
  colorTimer();

}

// Setter fargen basert på hvilket counter-intervall som er gjeldene
void colorTimer() { 
  if( counter <= 5) {
    setColor(255, 0, 0);  // red

  }
  if( counter > 5 & counter <= 10) {
    setColor(0, 255, 0);  // red
  }

  if( counter > 10 & counter < 15) {
    setColor(0, 0, 255);  // red
  }

}

// funksjon som setter fargene, blir kalt på av colorTimer, 
void setColor(int red, int green, int blue){

  if (ledState == 1){
    analogWrite(redPin, red); 
    analogWrite(greenPin, green);
    analogWrite(bluePin, blue);  
  }
  if (ledState == 0){
    analogWrite(redPin, LOW); 
    analogWrite(greenPin, LOW);
    analogWrite(bluePin, LOW);  
  }
}

char getNumber (){

  if( counter < 5) {

    return ('1'); // red

  }
  if( counter >= 5 & counter < 10) {
    return ('2');  // red
  }

  if( counter >= 10 & counter < 15) {
    return ('3');  // red
  }

}


void acceleromter (){

   ///// START ACCELEROMTER _KODE/////////////////////////////////
 //read the analog values from the accelerometer
  int xRead = analogRead(xPin);
  int yRead = analogRead(yPin);
  int zRead = analogRead(zPin);

  //convert read values to degrees -90 to 90 - Needed for atan2
  int xAng = map(xRead, minVal, maxVal, -90, 90);
  int yAng = map(yRead, minVal, maxVal, -90, 90);
  int zAng = map(zRead, minVal, maxVal, -90, 90);

  //Caculate 360deg values like so: atan2(-yAng, -zAng)
  //atan2 outputs the value of -π to π (radians)
  //We are then converting the radians to degrees
  x = RAD_TO_DEG * (atan2(-yAng, -zAng) + PI);
  y = RAD_TO_DEG * (atan2(-xAng, -zAng) + PI);
  z = RAD_TO_DEG * (atan2(-yAng, -xAng) + PI);

// constrain klipper vekk verdiene over og under gitte verdier
x = constrain (x, 5, 360); 
y = constrain (y, 5, 360);
z = constrain (z, 5, 360);
//mapper verdien om til mer rgb-velnlige verdier :
x = map(x, 5, 360, 0, 255); 
y = map(y, 5, 360, 0, 255);
z = map(z, 5, 360, 0, 255);
 ///// SLUTT ACCELEROMTER _KODE/////////////////////////////////
  
aTrigger = (int(x)+int(y))/2;  //snitt av x, y og z for å dempe utslagsfaktor evt legg til + int(z);

if (aTrigger >= aSensitivity){  // konstanten for når den skal gi utslag settes med aSensitity (øvers)
aTriggerState = 1;
}
else { aTriggerState = 0;}


if (aTriggerState == 1 ){
    unsigned long currentMillis = millis();
if(currentMillis - previousMillis > aTriggerInterval) {
    // save the last time you blinked the LED 
    previousMillis = currentMillis;   
   
 // nullstille teller hvis den er over 15
      if (counter == 15){
        counter = 1;  
      }  
      Serial.print(getNumber());
      ledState = 1; // denne er der for å skry på lys
      counter++;
  }
}


}


