import processing.serial.*;

import ddf.minim.*;

Minim minim;
AudioPlayer lyd1, lyd2, lyd3;


Serial myPort; // The serial port:
int inByte;
int counter = 0;
int playNumber;


void setup() {
  size(400, 300);
  textSize(32);
  fill(165, 27, 27);

  println(Serial.list());

  // You may need to change the number in [ ] to match 
  // the correct port for your system
  myPort = new Serial(this, Serial.list()[4], 9600);
  minim = new Minim(this);


  //LASTE INN LYDER

  lyd1 = minim.loadFile("Lyd1.mp3", 2048); // 2080 er buffer size
  lyd2 = minim.loadFile("Lyd2.mp3", 2048);
  lyd3 = minim.loadFile("Lyd3.mp3", 2048);
}

void draw() {
  background(200);

  while (myPort.available () > 0) {
  
    inByte = myPort.read();
    println(char(inByte));
    playNumber = inByte - 48; // gjør om til char
    triggerSound();
  }

  text(playNumber, width/2, height/2);
}



void triggerSound() {
  //lese av status på sist innleste serialinput
  //spille av riktig lyd.
  switch (playNumber) {
  case 1:
    lyd1.rewind();
    lyd1.play();
    break;
  case 2:
    lyd2.rewind();
    lyd2.play();
    break;
  case 3:
    // if (lyd3.isPlaying() == false) { 
    lyd3.rewind();
    lyd3.play();
    // }
    break;
  }
}

void keyPressed()
{
  if ( key == '1' ) lyd1.play();
  if ( key == '2' ) lyd2.play();
}

